
#include"delay.h"

#ifndef DS_H_
#define DS_H_

#define DQ_H  P1OUT|=BIT0
#define DQ_L  P1OUT&=~BIT0
#define DQ      (P1IN&BIT0)
#define DirPort_OUT  P1DIR|=BIT0
#define DirPort_IN  P1DIR&=~BIT0

unsigned int read_temperature(uchar z);
uchar init_ds18b20(void);
uchar read_onechar(void);
void write_onechar(uchar dat);
void match_rom(uchar a);

uint ID[8];
uchar DQ_ID1[8]={0x28,0x72,0x1b,0xc6,0x03,0x00,0x00,0x30};
uchar DQ_ID2[8]={0x28,0xad,0x8f,0x33,0x04,0x00,0x00,0xf2};
uchar DQ_ID3[8]={0x28,0x5c,0x2e,0x10,0x03,0x00,0x00,0xcb};

/*------------------------------------------------
                    18b20ʼ
------------------------------------------------*/
uchar init_ds18b20(void)
{
	unsigned char dat;
	 DirPort_OUT;
	 DQ_H;    //DQλ
	 delayus(5);   //ʱ
	 DQ_L;         //ƬDQ
	 delayus(300); //ȷʱ  480us С960us
	 delayus(300);
	 DQ_H;        //
	 delayus(40); //15~60us  60-240usĴ
	 DirPort_IN;
	 dat=DQ;        //dat=0ʼɹ, dat=1ʼʧ
	 delayus(800); //ʱ
	 return dat;
}

/*------------------------------------------------
                    ȡһֽ
------------------------------------------------*/
uchar read_onechar(void)
{
	uchar i=0;
	uchar dat = 0;
	for (i=8;i>0;i--)
	 {
	  DirPort_OUT;
	  DQ_L; // ź
	  dat>>=1;
	  DQ_H; // ź
	  DirPort_IN;
	  if(DQ)
	   dat|=0x80;
	  else
		  dat &=0x7f;
	  delayus(35);
	 }
	 return(dat);
}
/*------------------------------------------------
                    дһֽ
------------------------------------------------*/
void write_onechar(uchar dat)
{
	 uchar i=0;
	 for (i=8; i>0; i--)
	 {
	  DirPort_OUT;
	  DQ_L;
	  delayus(15);     //15usд
	  if(dat&0x01)
		  DQ_H;
	  else
		  DQ_L;
	  delayus(70);
	  DirPort_IN;
	  dat>>=1;
	 }
}

void match_rom(uchar a)
{
	char j;
	write_onechar(0x55);	   //ƥROM
	if(a==1)
	{
	for(j=0;j<8;j++)
		write_onechar(DQ_ID1[j]);		//18B20кţȷ͵ֽ
	}
	if(a==2)
	{
	for(j=0;j<8;j++)
		write_onechar(DQ_ID2[j]);		//18B20кţȷ͵ֽ
	}
	if(a==3)
	{
	for(j=0;j<8;j++)
		write_onechar(DQ_ID3[j]);		//18B20кţȷ͵ֽ
	}
}

/*------------------------------------------------
                    ȡ¶
------------------------------------------------*/
unsigned int read_temperature(uchar z)
{
	uint a;
	uint b;
	uint t;

	init_ds18b20();
	write_onechar(0xcc);			 //к
	init_ds18b20();
	if(z==1)
	{
		match_rom(1);		 //ƥROM 1
	}
	if(z==2)
	{
		match_rom(2);		 //ƥROM	 2
	}
	if(z==3)
	{
		match_rom(3);		 //ƥROM	 2
	}
	write_onechar(0x44);//¶ת
	delayms(100);
	init_ds18b20();
	write_onechar(0xcc);				//к
	init_ds18b20();
	if(z==1)
	{
		match_rom(1);			    //ƥROM 1
	}
	if(z==2)
	{
		match_rom(2);				//ƥROM	 2
	}
	if(z==3)
	{
		match_rom(3);		 //ƥROM	 2
	}
	write_onechar(0xbe);//ȡ¶


	a=read_onechar();
	b=read_onechar();

	b<<=8;
	t=a+b;

	return t;

}

void read_ID()
{
 unsigned char n;
 init_ds18b20();
 write_onechar(0x33); //Skip ROM
 for(n=0;n<8;n++)
	 ID[n]=read_onechar();
}


#endif /* DS_H_ */
