/*
 * lcd12864.h
 *
 *  Created on: 2012-7-20
 *      Author: wsx
 */

#ifndef LCD12864_H_
#define LCD12864_H_

#include"delay.h"

#define CS_H  P2OUT|=BIT0
#define CS_L  P2OUT&=~BIT0
#define SID_H  P2OUT|=BIT1
#define SID_L  P2OUT&=~BIT1
#define SCLK_H  P2OUT|=BIT2
#define SCLK_L  P2OUT&=~BIT2
//#define PSB_L P2OUT&=~BIT3;

void sendbyte(uchar Data);
void write_com(uchar cmd);
void write_data(uchar Data);
void init_12864();
void write_12864string(uchar x,uchar y,char  *s);
void clear_12864();
void screen(void);

/********************************************************************
*  : sendbyte()
*  : ҺĴͨЭ飬
*  : zdata
*  : 
***********************************************************************/
void sendbyte(uchar Data)
{
	uint i;
	for(i=0; i<8; i++)
	{
		if((Data << i) & 0x80)
		{
			SID_H;
		}
		else
		{
			SID_L;
		}
		SCLK_L;
		SCLK_H;
	}
}

/********************************************************************
*  : write_com()
*  : дָ
*  : cmd
*  : 
***********************************************************************/
void write_com(uchar cmd)
{
	CS_H;
	sendbyte(0xf8);
	sendbyte(cmd & 0xf0);
	sendbyte((cmd << 4) & 0xf0);
	delayus(200);
}

/********************************************************************
*  : write_data()
*  : дָ
*  : cmdcode
*  : 
***********************************************************************/
void write_data(uchar Data)
{
	CS_H;
	sendbyte(0xfa);
	sendbyte(Data & 0xf0);
	sendbyte((Data << 4) & 0xf0);
	delayus(200);
}

/*------------------------------------------------
                   ʾַ
x:ֵΧ0~8
y:ֵΧ1~4
------------------------------------------------*/
void write_12864string(uchar x,uchar y,char  *s)
{
 switch(y)
     {
	  case 1: write_com(0x80+x);break;
	  case 2: write_com(0x90+x);break;
	  case 3: write_com(0x88+x);break;
	  case 4: write_com(0x98+x);break;
      default:break;
	 }
 while(*s>0)
   {
      write_data(*s);
      s++;
      delayus(100);
   }
}
/*------------------------------------------------
                      
------------------------------------------------*/
void clear_12864()
{
   write_com(0x01);
//   delayms(20);
//   write_com(0x02);
//   delayms(15);
}

void init_12864()
{
	P2DIR|=BIT0+BIT1+BIT2;
//   P2DIR|=BIT0+BIT1+BIT2+BIT3;
//   PSB_L;
//   delayms(40);           //40MSʱ
//   PSB_L;                 //Ϊ8BITڹģʽ
//   delayms(10);
   write_com(0x30);       //ѡָ
   delayus(50);         //ʱ100us
   write_com(0x30);       //ѡ8bit
   delayus(20);         //ʱ37us
   write_com(0x0c);       //ʾ(αꡢ)
   delayus(50);         //ʱ100us
   write_com(0x01);       //ʾ趨ַָΪ00H
   delayms(15);           //ʱ10ms
   write_com(0x06);       //ָϵĶȡдʱ趨αƶָʾλ1λƶ
   delayus(50);         //ʱ100us
}

void screen(void)
{
	write_12864string(1,1,"¿ϵͳ");
	write_12864string(0,2,":");
	write_12864string(0,3,":");
}

#endif /* LCD12864_H_ */
